#include <iostream.h>
#include <iomanip.h>
#include "apmatrix.h"

class Screen
{
  public:
    
	 enum Color {white, black};            // legal pixel values
     
	 Screen(int size);                     // all white screen size X size
    void DrawRectangle(int row, int col,  // draw rectangle on screen
				 int height, int width);

	 void FillRectangle(int row, int col);  // fill a rectangle
    void Clear();                          // set screen to all white

    void Print(ostream & output) const;
	 int  Size()  const;
    
  private:

	 int mySize;
	 apmatrix<Color> myPixels;
};


Screen::Screen(int size)
	 : mySize(size),
      myPixels(size,size,Screen::white)
// postcondition: size X size screen is all white
{

}

void Screen::DrawRectangle(int row, int col, int height, int width)
// precondition: screen is blank/all white,
//               0 <= row < Size() and 0 <= col < Size(),
//               height > 0, and width > 0
{

}
int Screen::Size() const
{
	 return mySize;
}

void Screen::Print(ostream & output) const
{
	 int j,k;
	 int size = Size();

	 // make top border

	 output << "  ";
	 for(j=0; j < size; j++)
	 {
	output << " " << setw(1) << j << " ";
	 }
	 output << endl;

	 for(j=0; j < size; j++)
	 {
	output << setw(1) << j << " ";
	for(k=0; k < size; k++)
	{
		 if (myPixels[j][k] == white)
		 {
		output << " - ";
		 }
		 else
		 {
		output << " * ";
		 }
	}
	output << endl << endl;
	 }
	 output << endl;
}

void Screen::Clear()
{
	 int j,k;
	 int size = Size();
	 for(j=0; j < size; j++)
	 {
	for(k=0; k < size; k++)
	{
		 myPixels[j][k] = white;
	}
	 }
}

void Screen::FillRectangle(int row, int col)
{


}

int main()
{
	 Screen s(8);
	 s.Print(cout);

	 s.DrawRectangle(1,2,5,4);
	 s.Print(cout);
	 s.Clear();

	 s.DrawRectangle(4,3,10,5);
	 s.Print(cout);
	 s.Clear();

	 s.DrawRectangle(4,4,8,9);
	 s.Print(cout);
	 s.Clear();

	 s.DrawRectangle(1,2,5,4);
	 s.FillRectangle(3,4);
	 s.Print(cout);
	 s.Clear();

	 s.DrawRectangle(4,3,10,5);
	 s.FillRectangle(6,6);
	 s.Print(cout);
	 s.Clear();

	 s.DrawRectangle(4,4,8,9);
	 s.FillRectangle(6,8);
	 s.Print(cout);
	 s.Clear();

}
