//listtest.cpp 						      12/1/97
// a program shell for the six singly-linked linear list lab exercises
#include <iostream.h>//cin and cout
#include <conio.h>	//clrscr() and getch()
#include "bool.h"		//false and true

//...global type definitions.........................................
struct node
{	int data;
	node * next;
	node(int val, node *ptr)	// constructor
		:data(val),
		 next (ptr)
	{ }
};

//...function prototypes.............................................
void createList(node* &head);
void freeMemory(node* &head);
void printList(node* head);
	void doCountNodes(node* head);
int  countNodes(node* head);
	void doInOrder(node* head);
bool inOrder(node* head);
	void doDeleteEnds(node* &head);
void deleteEnds(node* &head);
	void doRotate(node* &head);
void rotate(node* &head);
void showMenu();
void branch(int& choice, node* &head);

//...driver..........................................................
int main()
{
	node* head = NULL;
	int choice;

	createList(head);
	cout << "List:  ";
	printList(head);
	cout << endl;
   getch();
	do {
		showMenu();
		branch(choice, head);
	} while (choice);
	getch();
	return 0;
}

//...1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
void createList(node* &head)
	//pre-condition: the head of the list has been initialized
	//post-condition: head points to a lingly-linked linear list
	//	containing data entered by the user, most recent at front
{  node* temp = head;
	if (head)
		freeMemory(head);
	int numNodes, num;
	cout << "How many numbers do you want to enter? ";
	cin >> numNodes;
	cout << "Enter the numbers, pressing <Enter> when done:\n";



}

void freeMemory(node* &head)
   //pre-condition: the list contains unwanted nodes
   //post-condition: memory has been released for re-use; the list is empty
{
   node* curr;
   while (head)
   {
      curr = head;
      head = head->next;
      delete curr;
   }
}

//...2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.2.
void printList(node* head)
   //pre-condition: the list has been initialized and is possibly empty
   //post-condition: the contents of the list have been displayed,
   //   leaving the list unchanged; if empty, a message is printed
{
	if (!head)
		cout << "< empty >";
	else




}

//...3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.3.
void doCountNodes(node* head)
{
   cout << "The list ";
   printList(head);
   cout << " contain(s) " << countNodes(head) << " nodes.\n";
}

int countNodes(node* head)
   // pre-condition: the list has been initialized
   // post-condition: the node count is returned
{



}

//...4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.4.
void doInOrder(node* head)
{
   cout << "The list ";
   printList(head);
   if ( inOrder(head) )
      cout << " is in ascending order.\n";
	else
		cout << " is not in ascending order.\n";
}

bool inOrder(node* head)
   // pre-condition: the list has been initialized
   // post-condition: returns true if the data is in ascending order;
   // 		otherwise returns false
{




}

//...5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.5.
void doDeleteEnds(node* &head)
{
	cout << "Original list ";
	printList(head);
	cout << endl;
	if ( countNodes(head)>1 )
	{
		deleteEnds(head);
		cout << "List with ends deleted ";
		printList(head);
		cout << endl;
	}
	else
		cout << "The list does not contain at least two nodes.\n";
}

void deleteEnds(node* &head)
	// pre-condition: the list contains at least two nodes
	// post-condition: the two end nondes have been deleted with
	//		memory freed
{





}

//...6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.6.
void doRotate(node* &head)
{
	cout << "Original list ";
	printList(head);
	cout << endl;
	if (head)
	{
		rotate(head);
		cout << "List with first element moved to end ";
		printList(head);
		cout << endl;
	}
	else
		cout << "The list cannot be rotated.\n";
}

void rotate(node* &head)
	// pre-condition: the list is not empty
	// post-condition: the first node has been appended to the end
	//	without allocating new nodes or moving data between nodes
{





}

//...menu............................................................
void showMenu()
{
   clrscr();
   cout << "\n\n................................\n\n"
	<< "     1 - Create list		\n"
	<< "     2 - Print list			\n"
	<< "     3 - Count nodes		\n"
	<< "     4 - Check for ascending order 	\n"
	<< "     5 - Delete ends		\n"
	<< "     6 - Rotate			\n"
	<< "					\n"
	<< "     0 - Quit			\n"
	<< "\n..................................\n";
}

//...branch..........................................................
void branch(int& choice, node* &head)
{
   do {
      cout << "\nSelect the number of your choice: ";
      cin  >> choice;
   } while( choice<0 || choice>6 );
   if (choice)
      switch(choice)
      {
	 case 1: createList(head); 	break;
	 case 2: printList(head); 		break;
	 case 3: doCountNodes(head); 	break;
	 case 4: doInOrder(head); 		break;
	 case 5: doDeleteEnds(head); 	break;
	 case 6: doRotate(head);
      }
	getch();
}

