// Client test program for MoveNames
// Mary Johnson - February 11, 1999
#include <iostream.h>
#include "apstring.h"

struct NodeType
{	apstring name;
	NodeType * next;
	NodeType(apstring G, NodeType *N)
		: name (G),
		  next (N)
		{ }
};

void MoveNames(NodeType *& L, char Start, char End, NodeType *& M);
void Create(NodeType *& L);
void Show(NodeType * L);

int main ()
{  NodeType *L, *M;
	char Start, End, ans = 'n';
	do
	{	Create (L);
		cout << "Here is list L: " << endl;
		Show (L);
		cout << "List M to start at what letter? ";
		cin >> Start;
		if (Start > 'Z')
			Start = Start - ('a' - 'A');
		cout << "  and to end at what letter, inclusive? ";
		cin >> End;
		if (End > 'Z')
			End = End - ('a' - 'A');
		MoveNames (L, Start, End, M);
		cout << "Here is list L:   ";
		Show (L);
		cout << "Here is list M:   ";
		Show (M);
		cout << endl << "Do you wish to go again?  ";
		cin >> ans;
	}	while (ans == 'y' || ans == 'Y');
	return 0;
}
void Create(NodeType *& L)
{  L = new NodeType ("Debra",
		 new NodeType ("Donna",
		 new NodeType ("Elizabeth",
		 new NodeType ("Frances",
		 new NodeType ("Laura",
		 new NodeType ("Linda",
		 new NodeType ("Mary",
		 new NodeType ("Nancy",
		 new NodeType ("Paula",
		 new NodeType ("Rachael",
		 new NodeType ("Sally",
		 new NodeType ("Wendy",NULL))))))))))));
}
void Show(NodeType * L)
{	NodeType * trav = L;
	while (trav)
	{	cout << trav->name << ", " ;
		trav = trav->next;
	}
	cout << endl;
}
void MoveNames(NodeType * & L, char Start, char End, NodeType * & M)
// pre:    L points to a non-empty list of alphabetized names; M is empty;letter Start  letter End
// post:   the names in the range of Start . . End have been moved from list L to list M;  
//	  both lists maintain alphabetical order.

