// mylist.cpp								source file

	mylist :: mylist ( )
	{
		myHead = NULL;
		myCurrent = NULL;
	}
	mylist::mylist (const mylist & R)
	{
		myHead = NULL;
		if (R.myHead)
		{
			myHead = new node (R.myHead->info, NULL);
			node * myTrav = myHead;
			node * Rtrav = R.myHead->next;
			while (Rtrav)
			{
				myTrav->next = new node (Rtrav->info, NULL);
				myTrav = myTrav->next;
				Rtrav = Rtrav->next;
			}
		}

		myCurrent = myHead;
	}
	mylist::~mylist ( )
	{
		makeEmpty ( );
	}
	const mylist & mylist :: operator = ( const mylist & rhs)
	{
		if (this != &rhs)
		{
			makeEmpty( );
			myHead = NULL;
			if (rhs.myHead)
			{
				myHead = new node (rhs.myHead->info, NULL);
				node * myTrav = myHead;
				node * Rtrav = rhs.myHead->next;
				while (Rtrav)
				{
					myTrav->next = new node (Rtrav->info, NULL);
					myTrav = myTrav->next;
					Rtrav = Rtrav->next;
				}
			}
			myCurrent = myHead;
		}
		return *this;
	}

	void mylist :: startIteration ( )
	{
		myCurrent = myHead;
	}
	bool mylist :: nextData (int & item)
	{
		if (myCurrent == NULL)
			return false;
		item = myCurrent->info;
		myCurrent = myCurrent->next;
		return true;
	}
	void mylist :: insert (int item)
	{
		node * prev = NULL;
		node * curr = myHead;
		node * newNode = new node (item, NULL);
		while (curr && curr->info < item)
		{
			prev = curr;
			curr = curr->next;
		}
		newNode->next = curr;
		if (prev)
			prev->next = newNode;
		else myHead = newNode;
		myCurrent = newNode;
	}
	void mylist :: remove (int item)
	{
		node * prev = NULL;
		node * curr = myHead;
		while (curr && curr->info != item)
		{
			prev = curr;
			curr = curr->next;
		}
		if (curr)
		{
			if (prev)
				prev->next = curr->next;
			else myHead = curr->next;
         myCurrent = curr->next;
			delete curr;
		}
	}
	void mylist :: makeEmpty( )
	{
		node * temp;
		while ( myHead)
		{
			temp = myHead;
			myHead = myHead->next;
			delete temp;
		}
      myCurrent = NULL;
	}
