//mycirclq.cpp  	mycirclq class IMPLEMENTATION using one pointer
# include "bool.h"
// *******************************************************************
// My queue class for integers (not a template class)
// *******************************************************************

mycirclq::mycirclq()
{  mySize = 0;
	myback = NULL;
}
mycirclq::~mycirclq()
{  makeEmpty();
}
mycirclq :: mycirclq(const mycirclq & R )
{	if (! R.isEmpty())
	{  // first node
		nodetype * Rtrav = R.myback->next;  		     // tracks rhs
		myback = new nodetype(Rtrav->info,NULL);
		myback->next = myback;
		// rest of queue
		while (Rtrav != R.myback)
		{  Rtrav = Rtrav->next;
			myback->next = new nodetype(Rtrav->info,myback->next);
			myback = myback->next;
		}
		mySize = R.mySize;
	}
	else
	{  myback = NULL;
		mySize = 0;
	}
}

const int mycirclq::front(  )const
{  return myback->next->info;
}
bool mycirclq::isEmpty( )const
{  return (mySize == 0);
}
int mycirclq::length(  )const
{  return (mySize);
}

const mycirclq& mycirclq::operator = (const mycirclq &rhs)
{	if (&rhs == this)
		return *this;
	if (! rhs.isEmpty())
	{  makeEmpty( );
		// first node
		nodetype * Rtrav = rhs.myback->next;  		  // tracks rhs
		myback = new nodetype(Rtrav->info,NULL);
      myback->next = myback;
		// rest of queue
		while (Rtrav != rhs.myback)
		{
			Rtrav = Rtrav->next;
			myback->next = new nodetype(Rtrav->info,myback->next);
			myback = myback->next;
		}
		mySize = rhs.mySize;
	}
	else
	{  myback = NULL;
		mySize = 0;
	}
	return *this;
}
void mycirclq::enqueue(const int &item)
{
	 nodetype * temp = new nodetype (item,NULL);
	 if (isEmpty())
		  myback = temp;
	 else
		  temp->next = myback->next;
	 myback->next = temp;
	 myback = myback->next;
	 mySize++;
}
void mycirclq::dequeue(  )
{
	nodetype * prev = myback->next;
	if (myback == myback->next)      // one node
		myback = NULL;
	else myback->next = myback->next->next;
	delete prev;
	mySize--;
}
void mycirclq::dequeue(int &item)
{
	item = myback->next->info;
	dequeue();
}
void mycirclq::makeEmpty(  )
{
	while (! isEmpty())
		dequeue();
}
// used only for testing - erase when code is tested
void mycirclq:: show( )
{  if (! isEmpty())
	{  nodetype * trav = myback->next;
		do
		{  cout << trav->info << "  ";
         trav = trav->next;
		}  while (trav != myback->next);
		cout << endl;
	}
	else cout << "Queue is empty." << endl;
}

