#ifndef _MYCIRCLQ_H
#define _MYCIRCLQ_H
#include "bool.h"

// *******************************************************************
// My queue class for integers (not a template class)
// *******************************************************************


class mycirclq
{
public:

  // constructors/destructor

	 mycirclq( );                      // construct empty queue
	 mycirclq(const mycirclq& Q);	     // copy constructor
	 ~mycirclq( );			              // destructor

  // assignment

	 const mycirclq& mycirclq::operator=(const mycirclq &rhs);
         // (modify your mystack code)

  // accessors

	 const int front( )   const;      // return front (no dequeue)
	 bool      isEmpty( ) const;      // return true if empty else false
	 int       length( )  const;      // return number of elements in queue

  // modifiers

	 void enqueue(const int &item );  // insert item (at rear)
	 void dequeue( );                 // remove first element
	 void dequeue( int & item );      // combine front and dequeue
	 void makeEmpty( );               // make queue empty
    void show ( );                   // used only for testing
private:
	struct nodetype
	{
		int info;
		nodetype * next;          			// pointer to first element
		nodetype (int D, nodetype *N): info (D), next (N) { }
   };
	int mySize;                 // number of items currently in queue
	nodetype * myback;          // pointer to front of back of queue
};

// *******************************************************************
// Specifications for queue functions
//
// constructors/destructor
//
//  mycirclq( )
//     postcondition: the queue is empty
//
//  ~mycirclq( )
//     postcondition: queue is destroyed
//
// accessors
//
//  const itemType & front( )const
//     precondition: queue has n >= 1 elements
//     postcondition: returns e1, queue is unchanged
//
//  bool isEmpty( ) const
//     postcondition: returns true if queue is empty, false otherwise
//
//  int length( ) const
//     precondition: queue has n >= 0 elements
//     postcondition:  returns n
//
// modifiers:
//
//  void enqueue( const itemType & item )
//     precondition: queue has n >= 0 elements
//     postcondition: item has been added to the end
//
//  void dequeue( )
//     precondition: queue has n >= 1 elements
//     postcondition: first element has been removed
//
//  void dequeue( itemType & item )
//     precondition: queue had n >= 1 elements
//     postcondition: first element has been removed and item == e1
//
//  void makeEmpty( )
//     postcondition: queue is empty

#include "mycirclq.cpp"
#endif


