#ifndef _MYQUEUE_H
#define _MYQUEUE_H
#include "bool.h"

// *******************************************************************
// My queue class for integers (not a template class)
// *******************************************************************


class myqueue
{
public:

  // constructors/destructor

	 myqueue( );                       // construct empty queue
	 myqueue(const myqueue& Q);	     // copy constructor
	 ~myqueue( );			              // destructor

  // assignment

	 const myqueue& operator=(const myqueue &rhs);
         // (modify your mystack code)

  // accessors

	 const int front( )   const;      // return front (no dequeue)
	 bool      isEmpty( ) const;      // return true if empty else false
	 int       length( )  const;      // return number of elements in queue

  // modifiers

	 void enqueue(int item );  	    // insert item (at rear)
	 void dequeue( );                 // remove first element
	 void dequeue( int & item );      // combine front and dequeue
	 void makeEmpty( );               // make queue empty
	 void show ( );                   // used only for testing

private:
	struct nodetype
	{
		int info;
		nodetype * next;          			// pointer to first element
		nodetype (int D, nodetype *N): info (D), next (N) { }
   };
	int mysize;                 // number of items currently in queue
	nodetype * myfront;         // pointer to front of queue
	nodetype * myback;          // pointer to back of queue

};

// *******************************************************************
// Specifications for queue functions
//
// constructors/destructor
//
//  myqueue( )
//     postcondition: the queue is empty
//
//  ~myqueue( )
//     postcondition: queue is destroyed
//
// accessors
//
//  const int front( )const
//     precondition: queue has n >= 1 elements
//     postcondition: returns e1, queue is unchanged
//
//  bool isEmpty( ) const
//     postcondition: returns true if queue is empty, false otherwise
//
//  int length( ) const
//     precondition: queue has n >= 0 elements
//     postcondition:  returns n
//
// modifiers:
//
//  void enqueue( int item )
//     precondition: queue has n >= 0 elements
//     postcondition: item has been added to the end
//
//  void dequeue( )
//     precondition: queue has n >= 1 elements
//     postcondition: first element has been removed
//
//  void dequeue( int & item )
//     precondition: queue had n >= 1 elements
//     postcondition: first element has been removed and item == e1
//
//  void makeEmpty( )
//     postcondition: queue is empty

#include "myqueue.cpp"
#endif


