/*	BXT.CPP
This program evaluates an expression represented by a tree.
The program builds a binary expression tree (BXT) from a
postfix expression entered as a stream of characters,
displays it in prefix form and evaluates it.  For example,
the postfix expression 12+4* has the prefix form *+124 and
evaluates to 12. This program originated in Litvin's text C++ for You++.
*/

#include <iostream.h>
#include <conio.h>
#include "apstack.h"

struct node
{
	char info;		//represents either an operator or an operand
	node *left, *right;
};
typedef node* treetype;

void buildBXT(treetype &root);
bool operand(char ch);
void preorderWalk(treetype t);
int  eval(treetype t);
int  getValue(char ch);
int  applyOperation(char op, int a, int b);
bool isLeaf(treetype t);

int main()
{
	treetype root = NULL;
	clrscr();
	buildBXT(root);
	cout<< "The prefix expression  ";
	preorderWalk(root);
	cout << " has the value " << eval(root) << endl;
	getch();
	return(0);
}

int getValue(char digit)
// pre  - digit is in the range '0'..'9'
// post - returns the digit's integer value
{

}

int applyOperation(char op, int a, int b)
// pre  - op is either +, *, or -
// post - returns the sum, product, or difference
{


}

bool isLeaf(treetype t)
// returns true if the node is a leaf
{


}

int eval(treetype t)
// returns the value of the expression represented by BXT
{
	int value;
	if ( isLeaf(t) )						// info is an operand
		value = getValue(t->info);
	else									   // info is an operator
		value = applyOperation( t->info, eval(t->left),eval(t->right) );
	return(value);
}

bool operand(char ch)
// returns true if the character is a digit in the range '0'..'9'
{
	return( ch>='0' && ch<='9' );
}

void buildBXT(treetype &root)
// pre - root is NULL
// post- root points to the root node of a BXT

/*	This algorithm builds an expression tree from a postfix expression.
	The algorithm uses a temporary stack of pointers as it parses the
	entered postfix expression.
	--Going from left to right, get the next character.
	--Create a new node for the character.
		If it is an operand, make it a leaf node.
		If it is an  operator, pop a pointer from the stack and set
		  the new node's right child to it.  Pop another pointer
		  from the stack and set the new node's left child to it.
	--Push the pointer to the new node on the stack.
	At the end, the pointer to the root of the BXT will be the only
	remaining element on the stack.
*/
{



}

void  preorderWalk(treetype t)
// displays the BXT in prefix form
{

}

